public class UE7Aufgabe18 {

	// Warshall-Algorithmus
	public static int[][] kuerzesteEntfernung(int[][] matrix) {
		int[][] dist = new int[matrix.length][matrix.length];
		for (int von = 0; von < matrix.length; von++) {
			for (int nach = 0; nach < matrix.length; nach++) {
				dist[von][nach] = matrix[von][nach];
			}
		}
		for (int ueber = 0; ueber < matrix.length; ueber++) {
			for (int von = 0; von < matrix.length; von++) {
				for (int nach = 0; nach < matrix.length; nach++) {
					if (dist[von][ueber] != -1
							&& dist[ueber][nach] != -1
							&& (dist[von][nach] == -1 || dist[von][nach] > dist[von][ueber]
									+ dist[ueber][nach])) {
						dist[von][nach] = dist[von][ueber] + dist[ueber][nach];
					}
				}
			}
		}
		return dist;
	}

	// "intuitiver" Algorithmus
	public static int[][] kuerzesteEntfernung2(int[][] matrix) {
		int[][] dist = new int[matrix.length][matrix.length];
		for (int von = 0; von < matrix.length; von++) {
			for (int nach = 0; nach < matrix.length; nach++) {
				dist[von][nach] = matrix[von][nach];
			}
		}
		boolean veraendert;
		do {
			veraendert = false;
			for (int von = 0; von < matrix.length; von++) {
				for (int nach = 0; nach < matrix.length; nach++) {
					for (int ueber = 0; ueber < matrix.length; ueber++) {
						if (dist[von][ueber] != -1
								&& dist[ueber][nach] != -1
								&& (dist[von][nach] == -1 || dist[von][nach] > dist[von][ueber]
										+ dist[ueber][nach])) {
							dist[von][nach] = dist[von][ueber]
									+ dist[ueber][nach];
							veraendert = true;
						}
					}
				}
			}
		} while (veraendert);
		return dist;
	}

	public static void main(String[] args) {
		int[][] matrix = { { 0, 2, 2, -1 }, { -1, 0, -1, 3 }, { 1, -1, 0, 7 },
				{ -1, -1, -1, 0 } };
		int[][] dist = kuerzesteEntfernung(matrix);
		print(matrix);
		print(dist);
	}

	private static void print(int[][] matrix) {
		for (int von = 0; von < matrix.length; von++) {
			for (int nach = 0; nach < matrix.length; nach++) {
				System.out.print(matrix[von][nach] + "|");
			}
			System.out.println();
		}
		System.out.println();
	}
}
