class UE7Aufgabe24 {

	public static void main(String[] args) {
		int[] brett = { 2, 0, 0, 0, 0, -5, 0, -3, 0, 0, 0, 5, -5, 0, 0, 0, 3,
				0, 5, 0, 0, 0, 0, -2 };

		print(brett);
		backgamonSpielen(brett);
	}

	static void backgamonSpielen(int[] brett) {
		boolean aAmZug = true;
		while (!spielEnde(brett)) {
			int wuerfelZahl = wuerfeln();
			int zug = zugEingabe(aAmZug, wuerfelZahl);
			while (!zugOk(brett, aAmZug, zug, wuerfelZahl)) {
				IO.println("Falscher Zug! Bitte wiederholen!");
				zug = zugEingabe(aAmZug, wuerfelZahl);
			}
			zugAusfuehren(brett, aAmZug, zug, wuerfelZahl);
			print(brett);
			aAmZug = !aAmZug; // Spielerwechsel
		}
		gibSiegerBekannt(brett);
	}

	static boolean spielEnde(int[] brett) {
		int anzahlA = 0;
		int anzahlB = 0;
		for (int i = 0; i < brett.length; i++) {
			if (brett[i] > 0) {
				anzahlA += brett[i];
			} else if (brett[i] < 0) {
				anzahlB += abs(brett[i]);
			}
		}
		return anzahlA == 0 || anzahlB == 0;
	}

	static void gibSiegerBekannt(int[] brett) {
		int anzahlA = 0;
		int anzahlB = 0;
		for (int i = 0; i < brett.length; i++) {
			if (brett[i] > 0) { // S
				anzahlA += brett[i];
			} else if (brett[i] < 0) {
				anzahlB += abs(brett[i]);
			}
		}
		if (anzahlA == 0) {
			IO.println("Spieler A hat gewonnen!");
		} else {
			IO.println("Spieler B hat gewonnen!");
		}
	}

	static int wuerfeln() {
		return ((int) (Math.random() * 6)) + 1;
	}

	static int zugEingabe(boolean isA, int wuerfelZahl) {
		return IO.readInt("Wrfel = " + wuerfelZahl + "; Spieler "
				+ (isA ? "A" : "B") + ", Zungennummer eingeben: ");
	}

	static boolean zugOk(int[] brett, boolean isA, int zungenNummer,
			int wuerfelZahl) {
		if (zungenNummer == -1) {
			return true; // Spieler passt
		}
		if (zungenNummer < 0 || zungenNummer >= brett.length) { // falsche
																// Indizes
			return false;
		}
		if (isA) {
			if (brett[zungenNummer] <= 0) { // keine eigenen Steine
				return false;
			}
			if ((zungenNummer + wuerfelZahl < brett.length)
					&& brett[zungenNummer + wuerfelZahl] < 0) {
				// Zug auf fremdes Feld
				return false;
			}
			if ((zungenNummer + wuerfelZahl < brett.length)
					&& brett[zungenNummer + wuerfelZahl] == 5) { // schon
				// voll
				return false;
			}
		} else { // Spieler B
			if (brett[zungenNummer] >= 0) { // keine eigenen Steine
				return false;
			}
			if ((zungenNummer - wuerfelZahl >= 0)
					&& brett[zungenNummer - wuerfelZahl] > 0) {
				// Zug auf fremdes Feld
				return false;
			}

			if ((zungenNummer - wuerfelZahl >= 0)
					&& brett[zungenNummer - wuerfelZahl] == -5) { // schon
				// voll
				return false;
			}
		}
		return true;
	}

	static void zugAusfuehren(int[] brett, boolean isA, int zungenNummer,
			int wuerfelZahl) {
		if (zungenNummer == -1) {
			return; // Spieler passt
		}
		if (isA) {
			brett[zungenNummer]--; // Stein wegnehmen
			if (zungenNummer + wuerfelZahl < brett.length) {
				brett[zungenNummer + wuerfelZahl]++; // Stein hinlegen
			}
		} else {
			brett[zungenNummer]++; // Stein wegnehmen
			if (zungenNummer - wuerfelZahl >= 0) {
				brett[zungenNummer - wuerfelZahl]--; // Stein hinlegen
			}
		}
	}

	static void ausgeben(char zeichen, int anzahlZeichen) {
		for (int i = 0; i < anzahlZeichen - 1; i++) {
			IO.print(" ");
		}
		IO.print(zeichen);
	}

	static void ausgeben(int zahl, int anzahlZeichen) {
		for (int i = 0; i < anzahlZeichen - length(zahl); i++) {
			IO.print(" ");
		}
		IO.print(zahl);
	}

	static int length(int zahl) {
		if (zahl >= -9 && zahl <= -1) {
			return 2;
		} else if (zahl >= 0 && zahl <= 9) {
			return 1;
		} else {
			return length(zahl / 10) + 1;
		}
	}

	// komplexe Felddarstellung
	static void print(int[] brett) {
		// berechne maximale Zeichenlaenge
		int max = length(brett.length) + 1;

		// obere Nummerierung
		for (int i = brett.length / 2 - 1; i >= 0; i--) {
			ausgeben(i, max);
		}
		IO.println();

		// obere Felder
		for (int r = 1; r <= 5; r++) {
			for (int i = brett.length / 2 - 1; i >= 0; i--) {
				if (abs(brett[i]) >= r) {
					if (brett[i] < 0) {
						ausgeben('*', max);
					} else {
						ausgeben('+', max);

					}
				} else {
					ausgeben(' ', max);
				}
			}
			IO.println();
		}

		// mittlere Leerzeile
		IO.println();

		// untere Felder
		for (int r = 5; r >= 1; r--) {
			for (int i = brett.length / 2; i < brett.length; i++) {
				if (abs(brett[i]) >= r) {
					if (brett[i] < 0) {
						ausgeben('*', max);
					} else {
						ausgeben('+', max);
					}
				} else {
					ausgeben(' ', max);
				}
			}
			IO.println();
		}

		// untere Nummerierung
		for (int i = brett.length / 2; i < brett.length; i++) {
			ausgeben(i, max);
		}
		IO.println();
	}

	static int abs(int zahl) {
		return (zahl < 0 ? -zahl : zahl);
	}

}
