public class UE7Aufgabe44 {

	static int MAX = 100;

	static int[] speicher = new int[MAX]; // Speicher
	static int zeiger = 0; // Speicherelementzeiger

	static char[] zeichen; // Quelltext (Menge an Zeichen)
	static int zeichenIndex; // Index auf aktuelles Befehlszeichen

	static boolean syntaxFehler = false; // Flag fuer Syntaxfehler
	static boolean laufzeitFehler = false; // Flag fuer Laufzeitfehler
	static String fehlermeldung; // u.U. Fehlermeldung bei Syntaxfehler

	public static void main(String[] args) {

		// Programm einlesen
		String dateiname = IO
				.readString("Name einer Datei mit Brainfuck-Quellcode: ");
		zeichen = IO.readFileAsCharArray(dateiname);
		if (zeichen == null) {
			IO.println("Sorry, fehlerhafte Datei!");
			return;
		}

		// Programm interpretieren
		zeichenIndex = 0;
		while (zeichenIndex < zeichen.length) {
			interpretiereZeichen(zeichen[zeichenIndex]);
			if (syntaxFehler) {
				System.out.println("Syntaxfehler: " + fehlermeldung);
				return;
			}
			if (laufzeitFehler) {
				System.out.println("Laufzeitfehler: " + fehlermeldung);
				return;
			}
			zeichenIndex++;
		}

	}

	static void interpretiereZeichen(char zeichen) {
		switch (zeichen) {
		case '>':
			++zeiger;
			break;
		case '<':
			--zeiger;
			break;
		case '+':
			if (!laufzeitueberpruefung()) {
				return;
			}
			++(speicher[zeiger]);
			break;
		case '-':
			if (!laufzeitueberpruefung()) {
				return;
			}
			--(speicher[zeiger]);
			break;
		case '.':
			if (!laufzeitueberpruefung()) {
				return;
			}
			IO.print((char) speicher[zeiger]);
			break;
		case ';':
			if (!laufzeitueberpruefung()) {
				return;
			}
			speicher[zeiger] = IO.readChar();
			break;
		case '[':
			if (!laufzeitueberpruefung()) {
				return;
			}
			if (!findeSchleifenEnde()) {
				return; // Syntaxfehler
			}
			if (speicher[zeiger] == 0) {
				springeZumSchleifenEnde();
			}
			break;
		case ']':
			if (!laufzeitueberpruefung()) {
				return;
			}
			if (!findeSchleifenAnfang()) {
				return; // Syntaxfehler
			}
			if (speicher[zeiger] != 0) {
				springeZumSchleifenAnfang();
			}
			break;
		default: // kein Befehl; Kommentarzeichen
		}
	}
	
	static boolean findeSchleifenEnde() {
		int innereSchleife = 1;
		int suchIndex = zeichenIndex;
		while (true) {
			suchIndex++;
			if (suchIndex >= zeichen.length) {
				syntaxFehler = true;
				fehlermeldung = "Eine Schleife wird nicht geschlossen!";
				return false;
			}
			if (zeichen[suchIndex] == '[') {
				innereSchleife++;
			} else if (zeichen[suchIndex] == ']') {
				if (innereSchleife == 1) {
					return true; // Schleifenende gefunden
				}
				innereSchleife--;
			}
		}
	}
	
	static boolean findeSchleifenAnfang() {
		int innereSchleife = 1;
		int suchIndex = zeichenIndex;
		while (true) {
			suchIndex--;
			if (suchIndex < 0) {
				syntaxFehler = true;
				fehlermeldung = "Es fehlt eine ffnende Klammer ([)!";
				return false;
			}
			if (zeichen[suchIndex] == ']') {
				innereSchleife++;
			} else if (zeichen[suchIndex] == '[') {
				if (innereSchleife == 1) {
					return true; // Schleifenanfang gefunden
				}
				innereSchleife--;
			}
		}
	}

	static void springeZumSchleifenEnde() {
		int innereSchleife = 1;
		while (true) {
			zeichenIndex++;
			if (zeichen[zeichenIndex] == '[') {
				innereSchleife++;
			} else if (zeichen[zeichenIndex] == ']') {
				if (innereSchleife == 1) {
					return; // Schleifenende gefunden
				}
				innereSchleife--;
			}
		}
	}

	static void springeZumSchleifenAnfang() {
		int innereSchleife = 1;
		while (true) {
			zeichenIndex--;
			if (zeichen[zeichenIndex] == ']') {
				innereSchleife++;
			} else if (zeichen[zeichenIndex] == '[') {
				if (innereSchleife == 1) {
					return; // Schleifenende gefunden
				}
				innereSchleife--;
			}
		}
	}

	static boolean laufzeitueberpruefung() {
		boolean ok = zeiger >= 0 && zeiger < MAX;
		if (!ok) {
			laufzeitFehler = true;
			fehlermeldung = "Ungueltiges Speicherelement (Index = " + zeiger
					+ ")";
		}
		return ok;
	}

}
