public class UE7Aufgabe7 {

	public static void main(String[] args) {
		int[] zahlen1 = { 1, 4, 5, 6 };
		int[] zahlen2 = { 1, 4, 5 };
		System.out.println(gleich(zahlen1, zahlen2));

		int[][] matrix = { { 1, 4, 1 }, { 2, 2, 2 }, { 3, 0, 3 } };
		System.out.println(identischeSummen(matrix));
	}

	/**
	 * vergleicht zwei Arrays auf Gleichheit der Elemente
	 * 
	 * @param a1
	 *            erstes Array (!= null)
	 * @param a2
	 *            zweites Array (!= null)
	 * @return genau dann true, wenn alle Elemente gleich sind
	 */
	static boolean gleich(int[] a1, int[] a2) {
		if (a1.length != a2.length) {
			return false;
		}
		for (int i = 0; i < a1.length; i++) {
			if (a1[i] != a2[i]) {
				return false;
			}
		}
		return true;
	}

	/**
	 * ueberprueft eine n * n Matrix, ob die Summen der Zeilen, Spalten und
	 * Diagonalen identisch sind
	 * 
	 * @param matrix
	 *            (n*n - Matrix, != null)
	 * @return genau dann true, wenn die Summen der Zeilen, Spalten und
	 *         Diagoanlen identisch sind
	 */
	static boolean identischeSummen(int[][] matrix) {
		int summe = 0;
		for (int s = 0; s < matrix[0].length; s++) {
			summe = summe + matrix[0][s];
		}

		for (int z = 1; z < matrix.length; z++) {
			int summe2 = 0;
			for (int s = 0; s < matrix[z].length; s++) {
				summe2 = summe2 + matrix[z][s];
			}
			if (summe != summe2) {
				return false;
			}
		}

		for (int s = 0; s < matrix[0].length; s++) {
			int summe2 = 0;
			for (int z = 0; z < matrix.length; z++) {
				summe2 = summe2 + matrix[z][s];
			}
			if (summe != summe2) {
				return false;
			}
		}

		int summe2 = 0;
		for (int d = 0; d < matrix.length; d++) {
			summe2 = summe2 + matrix[d][d];
		}
		if (summe != summe2) {
			return false;
		}

		summe2 = 0;
		for (int d = 0; d < matrix.length; d++) {
			summe2 = summe2 + matrix[d][matrix.length - d - 1];
		}
		if (summe != summe2) {
			return false;
		}

		return true;
	}

	static int[][] matrixBilden(int[] a1, int[] a2, int[] a3) {
		int[][] matrix = new int[3][];
		matrix[0] = a1;
		matrix[1] = a2;
		matrix[2] = a3;
		return matrix;
	}

	static int[][] matrixBilden2(int[] a1, int[] a2, int[] a3) {
		int[][] matrix = new int[3][];
		if (a1 != null) {
			matrix[0] = new int[a1.length];
			for (int i = 0; i < a1.length; i++) {
				matrix[0][i] = a1[i];
			}
		}
		if (a2 != null) {
			matrix[1] = new int[a2.length];
			for (int i = 0; i < a2.length; i++) {
				matrix[1][i] = a2[i];
			}
		}
		if (a3 != null) {
			matrix[2] = new int[a3.length];
			for (int i = 0; i < a3.length; i++) {
				matrix[2][i] = a3[i];
			}
		}
		return matrix;
	}

}
