
public class UE7Aufgabe82 {

	/*
	 * Ein gutes Passwort sollte - mindestens acht Zeichen lang sein, - mindestens
	 * drei Buchstaben enthalten, - mindestens zwei Ziffern enthalten, - mindestens
	 * einen Grossbuchstaben enthalten - mindestens einen Kleinbuchstaben enthalten
	 * - und mindestens ein Sonderzeichen ($%&/\) enthalten
	 */
	static boolean isGoodPassword(String password) {
		char[] passwordChars = password.toCharArray();
		// 8 Zeichen
		if (passwordChars.length < 8) {
			return false;
		}

		// 1 Kleinbuchstaben
		int lowerLetters = 0;
		for (char ch : passwordChars) {
			if ('a' <= ch && ch <= 'z') {
				lowerLetters++;
			}
		}
		if (lowerLetters < 1) {
			return false;
		}

		// 1 Grossbuchstaben
		int upperLetters = 0;
		for (char ch : passwordChars) {
			if ('A' <= ch && ch <= 'Z') {
				upperLetters++;
			}
		}
		if (upperLetters < 1) {
			return false;
		}

		// 3 Buchstaben
		if (lowerLetters + upperLetters < 3) {
			return false;
		}

		// 2 Ziffern
		int digits = 0;
		for (char ch : passwordChars) {
			if ('0' <= ch && ch <= '9') {
				digits++;
			}
		}
		if (digits < 2) {
			return false;
		}

		// und 1 Sonderzeichen ($%&/\)
		for (char ch : passwordChars) {
			switch (ch) {
			case '$':
			case '%':
			case '&':
			case '/':
			case '\\':
				return true;
			}
		}

		return false;
	}

	public static void main(String[] args) {
		String password = IO.readString("Enter Password: ");
		while (!isGoodPassword(password)) {
			password = IO.readString("Bad Password! Enter Password: ");
		}
		System.out.println("ok");
	}

}
