
public class UE7Aufgabe86 {

	public static void main(String[] args) {
		// start of game
		final int numberOfCoins = 10; // arbitrary even number >= 4
		int[] coins = init(numberOfCoins);
		
		// print board
		print(coins);

		// play game
		while (!gameOver(coins)) {
			// enter move
			int fromIndex = IO.readInt("please enter the index from which to take a coin: ");
			int toIndex = IO.readInt("please enter the index where the coin shall be placed: ");
			
			// check move
			if (!checkMove(coins, fromIndex, toIndex)) {
				
				// invalid move, game ends 
				System.out.println("invalid move! looser!");
				return;
			}
			
			// execute valid move
			executeMove(coins, fromIndex, toIndex);
			
			// print new board
			print(coins);
		}

		// congratulate winner
		System.out.println("winner!");
	}

	static int[] init(int numberOfCoins) {
		int[] coins = new int[numberOfCoins];
		for (int i = 0; i < coins.length; i++) {
			coins[i] = 1;
		}
		return coins;
	}

	static void print(int[] coins) {
		System.out.println("Board");
		System.out.print("coins: ");
		for (int i = 0; i < coins.length; i++) {
			System.out.print(coins[i] + " ");
		}
		System.out.println();
		System.out.print("index: ");
		for (int i = 0; i < coins.length; i++) {
			System.out.print(i + " ");
		}
		System.out.println();
		System.out.println();
	}

	static boolean gameOver(int[] coins) {
		int twoCoins = 0;
		for (int i = 0; i < coins.length; i++) {
			if (coins[i] == 2) {
				twoCoins++;
			}
		}
		return twoCoins == coins.length / 2;
	}

	static boolean checkMove(int[] coins, int fromIndex, int toIndex) {
		if (fromIndex < 0) {
			return false;
		}
		if (fromIndex >= coins.length) {
			return false;
		}
		if (toIndex < 0) {
			return false;
		}
		if (toIndex >= coins.length) {
			return false;
		}
		if (toIndex == fromIndex) {
			return false;
		}
		if (coins[fromIndex] == 0) {
			return false;
		}
		if (coins[toIndex] != 1) {
			return false;
		}
		if (fromIndex < toIndex) {
			int skippedCoins = 0;
			for (int i = fromIndex + 1; i < toIndex; i++) {
				skippedCoins += coins[i];
			}
			return skippedCoins == 2;
		} else {
			int skippedCoins = 0;
			for (int i = fromIndex - 1; i > toIndex; i--) {
				skippedCoins += coins[i];
			}
			return skippedCoins == 2;
		}
	}

	static void executeMove(int[] coins, int fromIndex, int toIndex) {
		coins[toIndex]++;
		coins[fromIndex]--;
	}

}
